
 <head>
    <title>Chat App</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style>
      * { margin: 0; padding: 0; box-sizing: border-box; }
      .flex-container {
        margin: auto;
        display: flex;
        background-color: rgb(91, 238, 213);
        height: 96%;
        width: 960px;
        position: absolute;
        align-items: stretch;
        justify-content: center;
      }
      .flex-container > div {
        background-color: #f1f1f1;
        margin: 10px;
        padding: 20px;
        font-size: 20px;
        bottom: 0;
        overflow: auto;
        overscroll-behavior-y: contain;
        scroll-snap-type: y proximity;
        justify-content: center;
      }
      body { background-color:#a3aaa8; font: 13px Helvetica, Arial; }
      form { background: rgba(182, 176, 176, 0.856); padding: 3px; position: fixed; bottom: 0; width: 960px; }
      form input {  border-style: solid; border-width: 1px; padding: 10px; width: 85%; margin-right: .5%; }
      form button { width: 9%; background: rgb(91, 238, 213); border: none; padding: 10px; margin-left: 2%; }
      #messages { list-style-type: none; margin: 0; padding: 0; }
      #messages li { padding: 5px 10px; }
    </style>
  </head>


<body>
  <div class="flex-container">
    <div style="flex-grow: 7; flex-basis: 700px; margin-top:auto">
      <ul id="messages"></ul>
      <form action="/" method="POST" id="chatForm">
        <input id="m" autocomplete="off" autofocus= "on" placeholder= "type your message here..." /><button>Send</button>
      </form>
    </div >
    <div style="flex-grow: 3; flex-basis: 260px">
      <p> Online Users </p>
      <p id="demo"></p>
    </div>  
  </div>
</body>
<script src="/socket.io/socket.io.js"></script>
<script
  src="https://code.jquery.com/jquery-3.5.1.js"
  integrity="sha256-QWo7LDvxbWT2tbbQ97B53yJnYU3WhH/C8ycbRAkjPDc="
  crossorigin="anonymous"
></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.26.0/moment.min.js"></script>
<script>
  var counter = 1;
  var oldUsername = "User ";
  let userName = oldUsername.concat(counter);
  counter = counter + 1;
  document.getElementById("demo").innerHTML = userName;
  let ID = "";
  var socket = io();
  //send event that user has joined room
  socket.emit("join room", {username : userName});

  //receive data from server.
  socket.on('send data',(data)=>{
      ID = data.id; //ID will be used later
      console.log(" my ID:" + ID);
  })
  $("#m").focus();
  //when form is submitted, capture the input value and then send it to server
  document
    .getElementsByTagName("form")[0]
    .addEventListener("submit", function (event) {
      event.preventDefault();
      socket.emit("chat message", {
        value: document.getElementById("m").value,
        user: userName,
      });

      document.getElementById("m").value = "";
    });
  socket.on("chat message", (data) => {
    console.log(data.data.user + ": " + data.id);
      displayMessage(data);
  });

  socket.on('is_online', function(username) {
    $('#messages').append($('<li>').html(username));
  });

  function displayMessage(data) {
      let authorClass = "";
    let divClass = ""
    //verify that the user ID and the message sent ID is similar 
    if (data.id === ID) {
        console.log("This person has sent a message")
      authorClass = "me";
      divClass = "myDiv";
    } else {
      authorClass = "you";
      divClass = "yourDiv";
    }
    const div = document.createElement("div");
    div.className = divClass;
    const li = document.createElement("li");
    const p = document.createElement("p");
    p.className = "time";
    p.innerText = moment().format("hh:mm");
    div.innerHTML =
      '<p class="' +
      authorClass +
      '">' +
      data.data.user +
      "</p>" +
      '<p class="message"> ' +
      data.data.value +
      "</p>";
    div.appendChild(p);
    li.appendChild(div);

    document.getElementById("messages").appendChild(li);
    //scroll to the bottom
    window.scrollTo(0, document.body.scrollHeight);
  }
</script>
</html>